#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/un.h>

#ifndef uint16_t
typedef unsigned short uint16_t;
#endif

#define SERVER  "/tmp/serversocket"
#define SERVHOST  "gecos"
#define CLIENT  "/tmp/mysocket"
#define CLIENTHOST  "193.166.42.136"
/* "localhost" or the local name (found in /etc/hosts) doesn't work */
/* IP 127.0.0.1 (interface lo) cannot seem to converse with 193.xxx
   on interface eth0... */
#define MAXMSG  1024
#define PACKETS 1000050

int
main (void)
{
  int sock;
  char message[MAXMSG];
#if LOCAL
  extern int make_named_socket (const char *name);
  struct sockaddr_un name;
#else
  extern int make_socket (const char *hostname, uint16_t port);
  struct sockaddr_in name;
  struct hostent *hostinfo;
#endif
  size_t size;
  int nbytes;
  int i;

#if LOCAL
  /* Make my own client endpoint socket. */
  sock = make_named_socket (CLIENT);

  /* Initialize the server socket address. */
  name.sun_family = AF_LOCAL;
  strcpy (name.sun_path, SERVER);
  size = strlen (name.sun_path) + sizeof (name.sun_family);
#else
  /* Make my own client endpoint socket. */
  sock = make_socket (CLIENTHOST, 5556);

  /* Initialize the server socket address. */
  name.sin_family = AF_INET;
  name.sin_port = htons (5555);
  name.sin_addr.s_addr = htonl (INADDR_ANY);
  hostinfo = gethostbyname (SERVHOST);
  if (hostinfo == NULL)
    {
      fprintf (stderr, "Unknown host %s.\n", SERVHOST);
      exit (EXIT_FAILURE);
    }
  name.sin_addr = *(struct in_addr *) hostinfo->h_addr;
  size = sizeof(name);
#endif

  for (i=0; i<PACKETS; i++) {

    /* Format the message number. */
    sprintf(message, "%d", i);

  /* Send the datagram. */
  nbytes = sendto (sock, message, sizeof(message), 0,
                   (struct sockaddr *) & name, size);
  if (nbytes < 0)
    {
      perror ("sendto (client)");
      exit (EXIT_FAILURE);
    }

  // Experiment with bursts without sleeping.
  // 8 blocks: no effect.
  // 16 blocks: some rearrangement, occasional single packets late.
  // 32 blocks: starts to drop single packets.
#if 0
  if ((i % 1024) == 0) {
    usleep(1000);
  }
#endif
  // This is natural: the default Linux socket-level receive queue is 32kB
  // i.e. 31 of our packets...

#if 0
  /* Wait for a reply. */
  nbytes = recvfrom (sock, message, MAXMSG, 0, NULL, 0);
  if (nbytes < 0)
    {
      perror ("recfrom (client)");
      exit (EXIT_FAILURE);
    }

  /* Print a diagnostic message. */
  fprintf (stderr, "Client: got message: %s\n", message);
#endif

  }  /* for */

  /* Clean up. */
  remove (CLIENT);
  close (sock);
}
