#include <stdio.h>
#include <errno.h>
#include <stdlib.h>  /* rand() */
#include <sys/types.h>  /* open() */
#include <sys/stat.h>  /* open() */
#include <fcntl.h>  /* open() */
#include <unistd.h>  /* write() */
#include <assert.h>

void
randbuf(char *buf, ssize_t nbytes)
{
  int i;

  for (i=0; i<nbytes; i++) {
    buf[i] = (char)rand();
  }  /* for */
}  /* randbuf */


/* Two large ping-pong buffers. */
char *ppbuf[2];
char *ppbufend[2];
char *pp;
int which;

void
fillbuf(char *buf, ssize_t nbytes)
{
  int i;

  for (i=0; i<nbytes; i++) {
#if 1
    /* Skipping samples. */
    buf[i] = *pp;
    pp+=4;
#endif
#if 0
    /* Getting rid of magnitude bits. */
    {
      char c = *pp++;

      buf[i] = *pp;
    }
#endif
    if (pp > ppbufend[which]) {
      which = (which) ? 0 : 1;  /* toggle */
      pp = ppbuf[which];
    }
  }
}  /* fillbuf */


int
main (int argc, char **argv)
{
  int files = atoi(argv[1]);
  int blocks = atoi(argv[2]);
  ssize_t nbytes = atoi(argv[3]);
  ssize_t ppnbytes = atoi(argv[4]);
  char *buf = malloc(nbytes);
  char filename[255];
  int filenum;
  int blocknum;
  int fd;

  assert(buf);
  randbuf(buf, nbytes);

  assert( (ppbuf[0] = malloc(ppnbytes)) );
  randbuf(ppbuf[0], ppnbytes);
  ppbufend[0] = &(ppbuf[0][ppnbytes-1]);
  assert( (ppbuf[1] = malloc(ppnbytes)) );
  randbuf(ppbuf[1], ppnbytes);
  ppbufend[1] = &(ppbuf[1][ppnbytes-1]);
  which = 0;
  pp = ppbuf[which];

  for (filenum=0; filenum<files; filenum++) {
    snprintf(filename, sizeof(filename), "/local/nexgen/file%09d.dat", filenum);
    assert( (fd = open(filename, O_WRONLY|O_CREAT|O_TRUNC, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH)) != -1 );

    for (blocknum=0; blocknum < blocks; blocknum++) {
      assert( write(fd, buf, nbytes) == nbytes );
    }  /* for each block */

    assert( close(fd) == 0 );
  }  /* for each file */
  exit(EXIT_SUCCESS);
}  /* main */
