/* vsibcon.cc  --  Controlling the VSIB board and r/w of data files.  */
// A simplified (and therefore working) program to stop a running wr-loop 
// Changes vsibcliMode and exits with that value
// $Log$


#include "registration.h"
RCSID(vsibcon_c, "$Id$");


// Configuration/debugging defines.
#define XYZ1 1

// Potential parameters, now constants.
#define XYZ2 1

// Constants.
#define MYNAME "vsibcon: "

/* Upcoming wrshm.h: */
#define fourCharLong(a,b,c,d) ( ((long)a)<<24 | ((long)b)<<16 | ((long)c)<<8 | d )

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <errno.h>
#include <limits.h>
#include <math.h>
#include <time.h>
#include <string.h>

// For shared memory.
#include <sys/ipc.h>
#include <sys/shm.h>

#include "sh.h"
// Global shared struct,
// and a pointer to it, for shared memory references in Linux with 'sh->'.
ptSh sh = NULL;
/* ------------------------------------------------------------------ */
int main(int argc, char **argv)
{
  // Shared memory unique identifier (key) and the returned reference id.
  key_t shKey;
  char *header,*h;
  int shId = -1;

  // Create and initialize 'vsibcon--vsibcli--xvsibcon' shared memory.
  shKey = fourCharLong('v','s','i','b');
  assert( (shId = shmget(shKey, sizeof(tSh), IPC_CREAT | 0777)) != -1 );
  assert( (sh = (ptSh)shmat(shId, NULL, 0)) != (void *)-1 );
  sh->utc = 0.0;

  if (argc>1) {
  if (!strcmp(argv[1],"pause")) { 
    printf("Pausing the recording\n");
    sh->vsibcliMode=VCM_setParameters; // Not strictly right
    exit(sh->vsibcliMode);
  }
  else if (!strcmp(argv[1],"stop")) { 
    printf("Stopping the recording\n");
    sh->vsibcliMode=VCM_stop;
    exit(sh->vsibcliMode);
  }
  else if (!strcmp(argv[1],"start")) { 
    printf("Starting the recording\n");
    sh->vsibcliMode=VCM_record;
    exit(sh->vsibcliMode);
  }
  else if (!strncmp(argv[1],"-h",2)) { 
    header = (char *) calloc(160,sizeof(char));
    h=header;
    for (n=2;n<argc;n++) {sprintf(h,"%s_",argv[n]);h += (strlen(argv[n])+1);}
    /* 2 char+1 for station, 9+1 for source 6+1 for exp */ 
    header=(char *)realloc(header,sizeof(char)*(HEAD_SIZE));
    header[HEAD_SIZE-1]=0;
    strncpy(sh->vsi_header,header,HEAD_SIZE); 
  }}
  else { 
    printf("Unknown command\nUsage: %s stop|start|pause\n",argv[0]);
    exit(-1);
  }
  exit(0);
}
